// =================================================================== POSITIONS
struct position initPos(struct SS SS)
/*
	 Initialise a position
	 Note: possible constraints are not checked here. 
	 The position may be unfeasible	 
	 */
{
	int d;
	struct position pos;

	pos.size=SS.D;

	//  Random uniform
		for (d = 0; d < pos.size; d++)  
		{  
			pos.x[d] = alea (SS.min[d], SS.max[d]);
		}
		if(SS.valueNb>0) // If only some values are acceptable
			pos=valueAccept(pos,SS.valueNb) ;
	
	return pos;
}

// ================================================================== VELOCITIES
struct velocity initVel(struct position pos, struct SS SS)
{
	int d;

	struct velocity vel;		

	vel.size = pos.size;

	// Half-diff  0.5*(alea-x)

	for (d = 0; d < vel.size; d++)  
	{				
		vel.v[d] =
			(alea (SS.min[d], SS.max[d])-pos.x[d])/2;
	}

	return vel;
}

//==============================================================================
struct position initFar(struct problem pb, struct param param)
{
	// Try to find a new position that is "far" from all the memorised ones

	//Note: memPos is a global variable
	double coord[MMax];
	int d;
	double delta;
	double interv[2];

	int n;
	struct position XFar;

	XFar.size=pb.SS.D;

	for(d=0;d<pb.SS.D;d++) // For each dimension
	{

	for(n=0;n<memPos.size;n++) coord[n]=memPos.M[n].x[d]; // All the coordinates on
																									// this dimension
	
		qsort(coord,memPos.size,sizeof(coord[0]),compareDoubles); // Sort them
																									// by increasing order

		// Find the biggest intervall
		interv[0]=coord[0];
		interv[1]=coord[1];
		delta=interv[1]-interv[0];

		for(n=1;n<memPos.size-1;n++)
		{
			if(coord[n+1]-coord[n] < delta) continue;

			interv[0]=coord[n];
			interv[1]=coord[n+1];
			delta=interv[1]-interv[0];
		}

		XFar.x[d]=0.5*(interv[1]+interv[0]); // Take the middle

		// Particular case, xMax
		if(pb.SS.max[d]-coord[memPos.size-1] > delta)
		{
			XFar.x[d]=pb.SS.max[d];
			delta=pb.SS.max[d]-coord[memPos.size-1]; 
		}

		// Particular case, xMin
		if(coord[0]-pb.SS.min[d]> delta)
		{
			XFar.x[d]=pb.SS.min[d];
		}
	}

	XFar=discrete(XFar, pb);
	XFar.f=perf (XFar, pb);
	return XFar;

}

//============================================================
double potentiel(struct position X, struct archive list)
{
	double dist;
	int n;
	double pot=0;

	for(n=0;n<list.size;n++)
	{
		dist=distanceL(X,list.M[n],2);
		if(dist>zero) pot=pot+1./dist;
		else return infinity;	
	}

	return pot;

}