/* -----------------------------------------------------
 PARAMETERS and OPTIONS 
*/
param.formula=1; // Which formula to use to compute the number of
									// iterations between two checks. See SpreadIter()
param.spreadProba=1; //1; 
											// We want that the probability for a particle to be
											// informed my any other one after T time steps
											// is at least spreadProba. Then T is automatically
											// computed.
											// Particular case: set to zero => T=1
											// Suggested values:
											// formula   spreadProba
											//	1						1.0
											//  2, 3				0.9	
											
param.rule1=0;				// See PSO.c for details
param.rule2=1;

// -------------------------------------------------------------AUTOMATIC VALUES
// You may modify them, if you really want to ...
param.S = (int) (40 + 2 * sqrt(pb.SS.D));	// Initial swarm size 
//param.S=pb.SS.D+1;

// According to Clerc's Stagnation Analysis
param.w = 1 / (2 * log ((double) 2)); // 0.721
param.c1 = 0.5 + log ((double) 2); // 1.193
param.c2=param.c1; 


//---------------------------------------------------------- WARNINGS and ERRORS

if (runMax > RMax)  // Maximum number of runs
{
	runMax = RMax;
	printf("\nWARNING. No more than %i runs",RMax);
}

if (param.S > SMax)
{ 
	param.S = SMax;
	printf("\nWARNING. The swarm size can not be bigger than %i",SMax);
}

if(param.spreadProba>1)
{
	ERROR("param.spreadProba must be smaller than 1");
}

